using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;

namespace WinGrid_cs_73_clr2_Drag_Drop_Rows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.AllowDrop = true;

            DataTable dt = new DataTable("Customer");
            dt.Columns.Add("CustomerID", typeof(int));
            dt.Columns.Add("CustomerName", typeof(string));
            dt.Columns.Add("Address", typeof(string));
            dt.Columns.Add("DateOfJoin", typeof(DateTime));
            dt.Rows.Add(new object[] { 1, "John Lever", "South Street", DateTime.Now });
            dt.Rows.Add(new object[] { 2, "Walter Smith", "12/4 S MarkD", DateTime.Now });
            dt.Rows.Add(new object[] { 3, "Kathy Lever", "23/45 Honai", DateTime.Now });
            dt.Rows.Add(new object[] { 4, "George Wills", "233 Walter Street", DateTime.Now });
            ultraGrid1.DataSource = dt;

        }

        private void ultraGrid1_SelectionDrag(object sender, CancelEventArgs e)
        {
            ultraGrid1.DoDragDrop(ultraGrid1.Selected.Rows, DragDropEffects.Move);

        }

        private void ultraGrid1_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move; 
            UltraGrid grid = sender as UltraGrid;
            Point pointInGridCoords = grid.PointToClient(new Point(e.X, e.Y));

            if (pointInGridCoords.Y < 20)
                // Scroll up
                this.ultraGrid1.ActiveRowScrollRegion.Scroll(RowScrollAction.LineUp);
            else if (pointInGridCoords.Y > grid.Height - 20)
                // Scroll down
                this.ultraGrid1.ActiveRowScrollRegion.Scroll(RowScrollAction.LineDown);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
        }

        private void ultraGrid1_DragDrop(object sender, DragEventArgs e)
        {
            int dropIndex;

            //Get the position on the grid where the dragged row(s) are to be dropped.
            //get the grid coordinates of the row (the drop zone)
            UIElement uieOver = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(
            ultraGrid1.PointToClient(new Point(e.X, e.Y)));

            //get the row that is the drop zone/or where the dragged row is to be dropped
            UltraGridRow ugrOver = uieOver.GetContext(typeof(UltraGridRow), true) as
            UltraGridRow;

            if (ugrOver != null)
            {
                dropIndex = ugrOver.Index;    //index/position of drop zone in grid

                //get the dragged row(s)which are to be dragged to another position in the grid
                SelectedRowsCollection SelRows = (SelectedRowsCollection)e.Data.GetData(typeof(SelectedRowsCollection)) as
                SelectedRowsCollection;
                //get the count of selected rows and drop each starting at the dropIndex
                foreach (UltraGridRow aRow in SelRows)
                {
                    //move the selected row(s) to the drop zone
                    ultraGrid1.Rows.Move(aRow, dropIndex);
                }

            }
        }
    }
}